## libkolabxml 0.7.0

=== CMakeLists.txt ===
# The special language NONE is not available in cmake 2.6
if(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 6)
    project(Libkolabxml NONE)
else()
    project(Libkolabxml C)
endif()

cmake_minimum_required(VERSION 2.6)

option( BUILD_TESTS "Build the tests" TRUE )
option( DIST_ONLY "Build dist targets only (does not require a compiler)" FALSE )
option( PYTHON_BINDINGS "Build bindings for python" FALSE )
option( PHP_BINDINGS "Build bindings for php" FALSE )
option( CSHARP_BINDINGS "Build bindings for csharp" FALSE )
option( JAVA_BINDINGS "Build bindings for java" FALSE )


set(Libkolabxml_MODULE_DIR ${Libkolabxml_SOURCE_DIR}/cmake/modules)
set(CMAKE_MODULE_PATH ${Libkolabxml_MODULE_DIR})

# only available from cmake-2.8.0
if(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 7)
    cmake_policy(SET CMP0012 NEW)
endif()

# only available from cmake-2.8.4
if(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 7 AND
    ${CMAKE_PATCH_VERSION} GREATER 3)
    cmake_policy(SET CMP0017 NEW)
endif()

# Versioning
# x.y.z scheme
# Development versions are only x.y
#
# i.e.
# 0.1 (0.1 development version)
# 0.1.0 (first release)
# 0.1.1 (patch release for 0.1.0)
# 0.2 (0.2 development version)

set (Libkolabxml_VERSION_MAJOR 0)
set (Libkolabxml_VERSION_MINOR 7)
# Enable the full x.y.z version only for release versions
set (Libkolabxml_VERSION_PATCH 0)
set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}.${Libkolabxml_VERSION_PATCH}" )
# set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}" )

set (Libkolabxml_VERSION_STRING ${CMAKE_PROJECT_NAME}-${Libkolabxml_VERSION})
set (KOLAB_FORMAT_VERSION "3.0dev1")

message("Building DIST targets (make dist, make snapshot)")
#make dist requires a tag with ${ARCHIVE_NAME} (e.g. libkolabxml-0.2.0)
set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${Libkolabxml_VERSION})
add_custom_target(dist
    COMMAND git archive --prefix=${ARCHIVE_NAME}/ ${ARCHIVE_NAME}
        | bzip2 > ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

#snapshot of current development version
set(SNAPSHOTARCHIVE_NAME "${CMAKE_PROJECT_NAME}-${Libkolabxml_VERSION}-HEAD")
add_custom_target(snapshot
    COMMAND git archive --prefix=${SNAPSHOTARCHIVE_NAME}/ HEAD
        | bzip2 > ${CMAKE_BINARY_DIR}/${SNAPSHOTARCHIVE_NAME}.tar.bz2
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
        
#It's possible to make dist targets only using:
#cmake -DDIST_ONLY=TRUE  ..
if (DIST_ONLY)
    message("Building DIST targets ONLY (cmake -DDIST_ONLY=FALSE  .. for full build)")
    return()
endif()

#C++ is required from here on
enable_language(CXX)

set(LIB_INSTALL_DIR lib CACHE STRING "The directories where to install libraries to")
set(INCLUDE_INSTALL_DIR include CACHE STRING "The directory where to install headers to")
set(INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}/kolabxml)
set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/Libkolabxml )

configure_file(libkolabxml-version.h.cmake "${CMAKE_BINARY_DIR}/libkolabxml-version.h" @ONLY)

set(Boost_USE_MULTITHREADED ON)
find_package(Boost REQUIRED COMPONENTS thread)
if (Boost_FOUND)
    message("Found boost in ${Boost_INCLUDE_DIRS}")
endif (Boost_FOUND)

find_package(LibkolabxmlDependencies REQUIRED) # Must be after findboost

set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall" )

execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion
                OUTPUT_VARIABLE GCC_VERSION)
if (GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)
    message(STATUS "GCC Version >= 4.7, applying unqualified lookup workaround")
    # gcc 4.7 no longer performs unqualified lookups by default, see: http://gcc.gnu.org/gcc-4.7/porting_to.html.
    # This workaround is added for xsd code, which fails otherwise to compile. -fpermissive turns the errors into warnings. 
    # It's only temporary, and should be removed once xsd is fixed.
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive" ) 
endif()

file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/bindings)

set( SCHEMA_DIR ${CMAKE_SOURCE_DIR}/schemas )

# Generate bindings
# WARNING: The inclusion order in SCHEMAS matters with xerces < 3.1.0. It seems without XMLUni::fgXercesHandleMultipleImports at least kolabformat-xcard.xsd MUST be before xCard.xsd,
# otherwise the compiled schema will simply lack the definitions of kolabformat-xcard.xsd (this affects xsdbin only).
set( SCHEMAS
    ${SCHEMA_DIR}/ical/kolabformat-xcal.xsd
    ${SCHEMA_DIR}/ical/iCalendar-params.xsd
    ${SCHEMA_DIR}/ical/iCalendar-props.xsd
    ${SCHEMA_DIR}/ical/iCalendar-valtypes.xsd
    ${SCHEMA_DIR}/kolabformat-xcard.xsd
    ${SCHEMA_DIR}/xCard.xsd
    ${SCHEMA_DIR}/kolabformat.xsd
)

set( SCHEMA_SOURCEFILES  
    ${CMAKE_BINARY_DIR}/bindings/kolabformat.cxx
    ${CMAKE_BINARY_DIR}/bindings/xCard.cxx
    ${CMAKE_BINARY_DIR}/bindings/kolabformat-xcal.cxx
    ${CMAKE_BINARY_DIR}/bindings/kolabformat-xcard.cxx
    ${CMAKE_BINARY_DIR}/bindings/iCalendar-params.cxx
    ${CMAKE_BINARY_DIR}/bindings/iCalendar-props.cxx
    ${CMAKE_BINARY_DIR}/bindings/iCalendar-valtypes.cxx
#     bindings/iCalendar-link-extension.cxx
#     bindings/iCalendar-bw-extensions.cxx
#     bindings/iCalendar-ms-extensions.cxx
)

#xsdcxx cxx-tree --generate-xml-schema --generate-serialization --custom-type date_time --hxx-epilogue '#include "bindings/customtypes/xml-schema-custom.hxx"' xml-schema.xsd
# --generate-inline --extern-xml-schema xml-schema.xsd
# --cxx-suffix .cpp --hxx-suffix .h   
add_custom_command(OUTPUT ${SCHEMA_SOURCEFILES}
    COMMAND ${XSDCXX} cxx-tree --generate-polymorphic --generate-serialization  --namespace-map http://kolab.org=KolabXSD --root-element icalendar --root-element vcards --root-element note --root-element configuration --output-dir ${CMAKE_BINARY_DIR}/bindings ${SCHEMAS}
    COMMENT "Generating XSD bindings"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    DEPENDS ${SCHEMAS}
    VERBATIM
    )

# Compile xsdbin if not found
if (NOT XSDBIN_FOUND)
    add_executable(xsdbin compiled/xsdbin.cxx)
    target_link_libraries(xsdbin ${XERCES_C})
    set(XSDBIN ${CMAKE_BINARY_DIR}/xsdbin)
endif ()

# Compile Schemas
add_custom_command(OUTPUT kolabformat-xcal-schema.cxx
        COMMAND ${XSDBIN} --verbose --array-name iCalendar_schema --output-dir ${CMAKE_BINARY_DIR} ${SCHEMAS}
        COMMENT "Compiling Kolab XSD schema"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        DEPENDS ${SCHEMAS} ${XSDBIN}
        VERBATIM
    )

set( SCHEMA_SOURCEFILES ${SCHEMA_SOURCEFILES} ${CMAKE_BINARY_DIR}/kolabformat-xcal-schema.cxx)

# ---------

SET_SOURCE_FILES_PROPERTIES(${SCHEMA_SOURCEFILES} PROPERTIES GENERATED 1)
ADD_CUSTOM_TARGET(generate_bindings ALL DEPENDS ${SCHEMA_SOURCEFILES})

include_directories(
    ./
    compiled
    src/containers
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${XSDCXX_INCLUDE_DIRS}
    ${XERCES_C_INCLUDE_DIRS}
    ${CURL_INCLUDE_DIRS}
)


add_subdirectory(src)

if (BUILD_TESTS)
    add_subdirectory(tests)
endif()

install(EXPORT LibkolabxmlExport DESTINATION ${CMAKECONFIG_INSTALL_DIR} FILE LibkolabxmlTargets.cmake )

file(RELATIVE_PATH relInstallDir ${CMAKE_INSTALL_PREFIX}/${CMAKECONFIG_INSTALL_DIR} ${CMAKE_INSTALL_PREFIX} )

configure_file(${Libkolabxml_MODULE_DIR}/LibkolabxmlConfig.cmake.in ${Libkolabxml_BINARY_DIR}/LibkolabxmlConfig.cmake @ONLY )
configure_file(${Libkolabxml_MODULE_DIR}/LibkolabxmlConfigVersion.cmake.in ${Libkolabxml_BINARY_DIR}/LibkolabxmlConfigVersion.cmake @ONLY )
# Install these two files into the same directory as the generated exports-file.
install(FILES ${Libkolabxml_BINARY_DIR}/LibkolabxmlConfig.cmake ${Libkolabxml_BINARY_DIR}/LibkolabxmlConfigVersion.cmake
        DESTINATION ${CMAKECONFIG_INSTALL_DIR} )

=== tests/CMakeLists.txt ===
find_package(Qt4)

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/.. )
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include_directories(${QT_INCLUDES} ${QT_INCLUDE_DIR} QtCore)
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--no-undefined" ) 
if (QT4_FOUND)
    message("Buildings tests")
    QT4_AUTOMOC(bindingstest.cpp)
    add_executable(bindingstest bindingstest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${BINDINGSTEST_MOC})
    target_link_libraries(bindingstest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})

    QT4_AUTOMOC(conversiontest.cpp)
    add_executable(conversiontest conversiontest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${CONVERSIONTEST_MOC})
    target_link_libraries(conversiontest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})

    QT4_AUTOMOC(parsingtest.cpp)
    add_executable(parsingtest parsingtest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${CONVERSIONTEST_MOC})
    target_link_libraries(parsingtest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
else()
    message(WARNING "Could not build tests because qt is missing")
endif()

=== src/csharp/CMakeLists.txt ===
# Generate C# wrapper
include_directories(../)

# Compile CSHARP Bindings
find_program(GMCS NAMES gmcs HINTS /usr/bin/)

if (NOT GMCS)
    message("gmcs not found, not building csharp bindings")
    return()
endif()

set(KOLAB_SWIG_CSHARP_SOURCE_FILE ${CMAKE_CURRENT_BINARY_DIR}/csharp_kolabformat_wrapper.cpp) #it seems we never use this file? it works at least as a dependecy.
set(KOLAB_SWIG_CSHARP_DLL_FILE ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.dll)
set(KOLAB_SWIG_CSHARP_TEST_FILE ${CMAKE_CURRENT_BINARY_DIR}/test.exe)

add_custom_command(OUTPUT ${KOLAB_SWIG_CSHARP_SOURCE_FILE}
        COMMAND ${SWIG} -v -c++ -csharp -o ${KOLAB_SWIG_CSHARP_SOURCE_FILE}  ../kolabformat.i
        COMMENT "Generating C# bindings"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS ../kolabformat.i kolabxml
        VERBATIM
    )

SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_CSHARP_SOURCE_FILE} PROPERTIES GENERATED 1)

configure_file(test.cs ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)

FILE(GLOB CSHARP_GENERATED_SOURCE_FILES "${CMAKE_CURRENT_BINARY_DIR}/*.cs")
LIST( REMOVE_ITEM CSHARP_GENERATED_SOURCE_FILES "${CMAKE_CURRENT_BINARY_DIR}/kolabformat.cs") #this one must be first so we remove and readd later
SET_SOURCE_FILES_PROPERTIES(${CSHARP_GENERATED_SOURCE_FILES} PROPERTIES GENERATED 1)
LIST( REMOVE_ITEM CSHARP_GENERATED_SOURCE_FILES "${CMAKE_CURRENT_BINARY_DIR}/test.cs") #not a generated file

add_custom_command(OUTPUT ${KOLAB_SWIG_CSHARP_DLL_FILE}
        COMMAND ${GMCS} -target:library "${CMAKE_CURRENT_BINARY_DIR}/kolabformat.cs" ${CSHARP_GENERATED_SOURCE_FILES}
        COMMENT "Compiling C# library"
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        DEPENDS kolabxml ${KOLAB_SWIG_CSHARP_SOURCE_FILE} ${CSHARP_GENERATED_SOURCE_FILES}
        VERBATIM
    )

add_custom_command(OUTPUT ${KOLAB_SWIG_CSHARP_TEST_FILE}
        COMMAND ${GMCS} -reference:${KOLAB_SWIG_CSHARP_DLL_FILE} ${CMAKE_CURRENT_BINARY_DIR}/test.cs
        COMMENT "Compiling C# test.exe"
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        DEPENDS kolabxml ${KOLAB_SWIG_CSHARP_SOURCE_FILE} ${KOLAB_SWIG_CSHARP_DLL_FILE}
        VERBATIM
    )

SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_CSHARP_DLL_FILE} PROPERTIES GENERATED 1)
SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_CSHARP_TEST_FILE} PROPERTIES GENERATED 1)
ADD_CUSTOM_TARGET(generate_csharp_bindings ALL DEPENDS ${KOLAB_SWIG_CSHARP_DLL_FILE} ${KOLAB_SWIG_CSHARP_TEST_FILE})

set(CSHARP_INSTALL_DIR "${CMAKE_CURRENT_BINARY_DIR}/csharpbindings" CACHE STRING "Install directory for csharp bindings.")

#not sure about the LIBRARY here, but might work
install(FILES ${KOLAB_SWIG_CSHARP_DLL_FILE} DESTINATION ${CSHARP_INSTALL_DIR})
install(FILES ${KOLAB_SWIG_CSHARP_TEST_FILE} DESTINATION ${CSHARP_INSTALL_DIR})

=== src/java/CMakeLists.txt ===
# Generate Java wrapper
include_directories(../)

set(KOLAB_SWIG_JAVA_SOURCE_FILE java_kolabformat_wrapper.cpp)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${KOLAB_SWIG_JAVA_SOURCE_FILE}
    COMMAND ${SWIG} -v -c++ -java -o ${CMAKE_CURRENT_BINARY_DIR}/${KOLAB_SWIG_JAVA_SOURCE_FILE}  ../kolabformat.i
    COMMENT "Generating Java bindings"
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ../kolabformat.i kolabxml
    VERBATIM
    )
SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_JAVA_SOURCE_FILE} PROPERTIES GENERATED 1)
ADD_CUSTOM_TARGET(generate_JAVA_bindings ALL DEPENDS ${KOLAB_SWIG_JAVA_SOURCE_FILE})

# Compile JAVA Bindings

# set(JAVA_INSTALL_DIR "${CMAKE_CURRENT_BINARY_DIR}/javabindings" CACHE STRING "Install directory for java bindings.")

=== src/php/CMakeLists.txt ===
#Generate PHP wrapper
include_directories(../)

set(KOLAB_SWIG_PHP_SOURCE_FILE php_kolabformat_wrapper.cpp)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${KOLAB_SWIG_PHP_SOURCE_FILE} ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.php
        COMMAND ${SWIG} -v -c++ -php -o ${CMAKE_CURRENT_BINARY_DIR}/${KOLAB_SWIG_PHP_SOURCE_FILE}  ../kolabformat.i
        COMMENT "Generating php bindings"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS ../kolabformat.i kolabxml
        VERBATIM
    )

SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_PHP_SOURCE_FILE} PROPERTIES GENERATED 1)
ADD_CUSTOM_TARGET(generate_php_bindings ALL DEPENDS ${KOLAB_SWIG_PHP_SOURCE_FILE})


#Compile PHP Bindings
# Since there is no php library we can't compile with -Wl,--no-undefined
if (APPLE)
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flat_namespace -undefined suppress" )
endif()

find_package(PHP4 5.3 REQUIRED)

if (PHP4_FOUND)
    include_directories(${PHP4_INCLUDE_PATH})
    add_library(phpbindings SHARED ${KOLAB_SWIG_PHP_SOURCE_FILE})
    target_link_libraries(phpbindings kolabxml ${PHP_LIBRARIES})
    SET_TARGET_PROPERTIES(phpbindings PROPERTIES OUTPUT_NAME "kolabformat")
    SET_TARGET_PROPERTIES(phpbindings PROPERTIES PREFIX "")

    configure_file(test.php ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)

    set(PHP_INSTALL_DIR "${CMAKE_CURRENT_BINARY_DIR}/phpbindings" CACHE STRING "Install directory for php bindings.")

    install(TARGETS phpbindings LIBRARY DESTINATION ${PHP_INSTALL_DIR})

    install( FILES
            ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.php
            DESTINATION ${PHP_INSTALL_DIR}
        )
else(PHP4_FOUND)
    message(WARNING "not building php bindings because php was not found")
endif (PHP4_FOUND)

=== debian/changelog ===
libkolabxml (0.7.0-0ubuntu3) quantal; urgency=low

  * Add kubuntu_fix_curl_constness.patch to fix building
  * Use non-versioned boost -dev packages to improve backprotability

 -- Harald Sitter <apachelogger@ubuntu.com>  Wed, 12 Sep 2012 21:07:57 +0200

libkolabxml (0.7.0-0ubuntu2) quantal; urgency=low

  * Add libcurl4-gnutls-dev build-dep

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 19 Jul 2012 13:36:30 +0100

libkolabxml (0.7.0-0ubuntu1) quantal; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 19 Jul 2012 12:33:20 +0100

libkolabxml (0.6.0+repack1-0ubuntu3) quantal; urgency=low

  * Enable parallel building.
  * Switch to debhelper compat level v9 which exports build flags.
  * Add a watch file.

 -- Felix Geyer <debfx@ubuntu.com>  Tue, 17 Jul 2012 19:16:09 +0200

libkolabxml (0.6.0+repack1-0ubuntu2) quantal; urgency=low

  * Initial release.
  * .orig repacked with copying licences from upstream

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 05 Jul 2012 12:55:57 +0100

=== debian/control ===
Source: libkolabxml
Section: libs
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonathan Riddell <jriddell@ubuntu.com>
Build-Depends: cmake,
               debhelper (>= 9),
               libxerces-c-dev,
               xsdcxx,
               uuid-dev,
               libboost-dev,
               libboost-thread-dev,
               swig2.0,
               libcurl4-gnutls-dev,
Standards-Version: 3.9.3
Homepage: http://git.kolab.org/libkolabxml

Package: libkolabxml0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Kolab Format 3.0 serialization, read and write library
 libkolabxml is a slim, lightweight Kolab Format 3.0 serialization,
 read and write library.

Package: libkolabxml-dev
Section: libdevel
Architecture: any
Depends: libkolabxml0 (= ${binary:Version}),
         ${misc:Depends}
Description: Kolab Format 3.0 serialization, read and write library
 libkolabxml is a slim, lightweight Kolab Format 3.0 serialization,
 read and write library.
 .
 This package contains the development files for the library.

## libkolabxml 0.8.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -40,9 +40,9 @@
 # 0.2 (0.2 development version)
 
 set (Libkolabxml_VERSION_MAJOR 0)
-set (Libkolabxml_VERSION_MINOR 7)
+set (Libkolabxml_VERSION_MINOR 8)
 # Enable the full x.y.z version only for release versions
-set (Libkolabxml_VERSION_PATCH 0)
+set (Libkolabxml_VERSION_PATCH 2)
 set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}.${Libkolabxml_VERSION_PATCH}" )
 # set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}" )
 
@@ -82,7 +82,7 @@
 configure_file(libkolabxml-version.h.cmake "${CMAKE_BINARY_DIR}/libkolabxml-version.h" @ONLY)
 
 set(Boost_USE_MULTITHREADED ON)
-find_package(Boost REQUIRED COMPONENTS thread)
+find_package(Boost REQUIRED COMPONENTS thread system)
 if (Boost_FOUND)
     message("Found boost in ${Boost_INCLUDE_DIRS}")
 endif (Boost_FOUND)
@@ -180,6 +180,7 @@
 add_subdirectory(src)
 
 if (BUILD_TESTS)
+    enable_testing()
     add_subdirectory(tests)
 endif()

=== src/CMakeLists.txt ===

#This property is not available anymore here, although present in the parent file.
SET_SOURCE_FILES_PROPERTIES(${SCHEMA_SOURCEFILES} PROPERTIES GENERATED 1)

set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wp,-D_FORTIFY_SOURCE=2 -O2" ) #always generate shared libraries with -fPIC, -D_FORTIFY_SOURCE=2 enables some extra checking

# Library with serialization/deserialization code and kolab-containers
add_library(kolabxml SHARED
    kolabformat.cpp
    containers/kolabcontainers.cpp
    containers/kolabnote.cpp
    containers/kolabevent.cpp
    containers/kolabtodo.cpp
    containers/kolabjournal.cpp
    containers/kolabcontact.cpp
    containers/kolabconfiguration.cpp
    containers/kolabfreebusy.cpp
    utils.cpp base64.cpp uriencode.cpp
    ../compiled/XMLParserWrapper.cpp
    ../compiled/grammar-input-stream.cxx
    ${SCHEMA_SOURCEFILES}
)
add_dependencies(kolabxml generate_bindings)
target_link_libraries(kolabxml ${XERCES_C} ${Boost_LIBRARIES} ${UUID} ${CURL})

# For the core library we can be stricter when compiling. This doesn't work with the auto generated code though.
if (${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION} VERSION_LESS 1.42)
    # We can't be as strict on with older versions of boost it seems (not sure if this is the exact version number where it breaks)
    # Since this is only for el5 compatibility we relax the rules (resulting in a couple of warning but a working build)
    #for development add here -Werror -Wfatal-errors (but don't for releases)
    set_target_properties(kolabxml PROPERTIES COMPILE_FLAGS "-Wall -Wextra -Wconversion")
else() #then normal case
    #for development add here -Werror -Wfatal-errors (but don't for releases)
    set_target_properties(kolabxml PROPERTIES COMPILE_FLAGS "-Wall -Wextra -Wconversion -Wl,--no-undefined")
endif()

set_target_properties(kolabxml PROPERTIES VERSION ${Libkolabxml_VERSION} SOVERSION ${Libkolabxml_VERSION_MAJOR})

install(TARGETS kolabxml EXPORT LibkolabxmlExport 
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

install( FILES
    kolabformat.h
    containers/kolabevent.h
    containers/kolabevent_p.h
    containers/incidence_p.h
    containers/kolabtodo.h
    containers/kolabjournal.h
    containers/kolabcontact.h
    containers/kolabnote.h
    containers/kolabcontainers.h
    containers/kolabconfiguration.h
    containers/kolabfreebusy.h
    global_definitions.h
    DESTINATION ${INCLUDE_INSTALL_DIR})

#-----------------------SWIG--------------------
# Building of the bindings can be controlled using the switches along the lines of: cmake -DPHP_BINDINGS=TRUE -DCSHARP_BINDINGS=FALSE ..
if (SWIG_FOUND)
    if(CSHARP_BINDINGS)
        message("building csharp bindings")
        add_subdirectory(csharp)
    endif(CSHARP_BINDINGS)
    if(JAVA_BINDINGS)
        message("building java bindings")
        add_subdirectory(java)
    endif(JAVA_BINDINGS)
    if(PYTHON_BINDINGS)
        message("building python bindings")
        add_subdirectory(python)
    endif(PYTHON_BINDINGS)
    if(PHP_BINDINGS)
        message("building php bindings")
        add_subdirectory(php)
    endif(PHP_BINDINGS)
else()
    message(WARNING "Could not build SWIG bindings, because SWIG is missing.")
endif()

=== tests/CMakeLists.txt ===
find_package(Qt4)
add_definitions(-DTEST_DATA_PATH="${CMAKE_CURRENT_SOURCE_DIR}")

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/.. )
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include_directories(${QT_INCLUDES} ${QT_INCLUDE_DIR} QtCore)
if (NOT APPLE)
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--no-undefined" ) 
endif()

if (QT4_FOUND)
    message("Buildings tests")
    QT4_AUTOMOC(bindingstest.cpp)
    add_executable(bindingstest bindingstest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${BINDINGSTEST_MOC})
    target_link_libraries(bindingstest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(bindingstest ${CMAKE_CURRENT_BINARY_DIR}/bindingstest)

    QT4_AUTOMOC(conversiontest.cpp)
    add_executable(conversiontest conversiontest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${CONVERSIONTEST_MOC})
    target_link_libraries(conversiontest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(conversiontest ${CMAKE_CURRENT_BINARY_DIR}/conversiontest)

    QT4_AUTOMOC(parsingtest.cpp)
    add_executable(parsingtest parsingtest.cpp ${CMAKE_CURRENT_BINARY_DIR}/${CONVERSIONTEST_MOC})
    target_link_libraries(parsingtest ${QT_QTTEST_LIBRARY} ${QT_QTCORE_LIBRARY} kolabxml ${XERCES_C})
    add_test(parsingtest ${CMAKE_CURRENT_BINARY_DIR}/parsingtest)
else()
    message(WARNING "Could not build tests because qt is missing")
endif()

=== src/csharp/CMakeLists.txt ===
--- 
+++ 
@@ -10,10 +10,66 @@
 endif()
 
 set(KOLAB_SWIG_CSHARP_SOURCE_FILE ${CMAKE_CURRENT_BINARY_DIR}/csharp_kolabformat_wrapper.cpp) #it seems we never use this file? it works at least as a dependecy.
+set(KOLAB_SWIG_CSHARP_FILES
+        ${CMAKE_CURRENT_BINARY_DIR}/Address.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Affiliation.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Alarm.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Attachment.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Attendee.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/CategoryColor.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/cDateTime.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Classification.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Configuration.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Contact.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/ContactReference.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Crypto.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/CustomProperty.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Cutype.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/DayPos.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Dictionary.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/DistList.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Duration.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/ErrorSeverity.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Event.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Geo.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Journal.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Key.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/kolabformatPINVOKE.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/NameComponents.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Note.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/PartStatus.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/RecurrenceRule.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Related.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Relative.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Role.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Status.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/SWIGTYPE_p_Kolab__Freebusy.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Telephone.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Todo.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Url.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectoraddress.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectoraffiliation.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectoralarm.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorattachment.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorattendee.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorcategorycolor.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorcontactref.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorcs.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectordatetime.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectordaypos.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorgeo.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectori.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorkey.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorrelated.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectors.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectortelephone.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorurl.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/Weekday.cs
+    )
 set(KOLAB_SWIG_CSHARP_DLL_FILE ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.dll)
 set(KOLAB_SWIG_CSHARP_TEST_FILE ${CMAKE_CURRENT_BINARY_DIR}/test.exe)
 
-add_custom_command(OUTPUT ${KOLAB_SWIG_CSHARP_SOURCE_FILE}
+add_custom_command(OUTPUT ${KOLAB_SWIG_CSHARP_SOURCE_FILE} ${KOLAB_SWIG_CSHARP_FILES}
         COMMAND ${SWIG} -v -c++ -csharp -o ${KOLAB_SWIG_CSHARP_SOURCE_FILE}  ../kolabformat.i
         COMMENT "Generating C# bindings"
         WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
@@ -22,19 +78,15 @@
     )
 
 SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_CSHARP_SOURCE_FILE} PROPERTIES GENERATED 1)
+SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_CSHARP_FILES} PROPERTIES GENERATED 1)
 
 configure_file(test.cs ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
 
-FILE(GLOB CSHARP_GENERATED_SOURCE_FILES "${CMAKE_CURRENT_BINARY_DIR}/*.cs")
-LIST( REMOVE_ITEM CSHARP_GENERATED_SOURCE_FILES "${CMAKE_CURRENT_BINARY_DIR}/kolabformat.cs") #this one must be first so we remove and readd later
-SET_SOURCE_FILES_PROPERTIES(${CSHARP_GENERATED_SOURCE_FILES} PROPERTIES GENERATED 1)
-LIST( REMOVE_ITEM CSHARP_GENERATED_SOURCE_FILES "${CMAKE_CURRENT_BINARY_DIR}/test.cs") #not a generated file
-
 add_custom_command(OUTPUT ${KOLAB_SWIG_CSHARP_DLL_FILE}
-        COMMAND ${GMCS} -target:library "${CMAKE_CURRENT_BINARY_DIR}/kolabformat.cs" ${CSHARP_GENERATED_SOURCE_FILES}
+        COMMAND ${GMCS} -target:library "${CMAKE_CURRENT_BINARY_DIR}/kolabformat.cs" ${KOLAB_SWIG_CSHARP_FILES}
         COMMENT "Compiling C# library"
         WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
-        DEPENDS kolabxml ${KOLAB_SWIG_CSHARP_SOURCE_FILE} ${CSHARP_GENERATED_SOURCE_FILES}
+        DEPENDS kolabxml ${KOLAB_SWIG_CSHARP_SOURCE_FILE} ${KOLAB_SWIG_CSHARP_FILES}
         VERBATIM
     )

=== src/php/CMakeLists.txt ===
--- 
+++ 
@@ -20,12 +20,21 @@
     set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flat_namespace -undefined suppress" )
 endif()
 
-find_package(PHP4 5.3 REQUIRED)
+# Debian (Wheezy) won't be able to find PHP using find_package. In packaging libkolabxml
+# for it, we define the include path and executable during the build.
+if (NOT PHP4_INCLUDE_PATH OR NOT PHP4_EXECUTABLE)
+    find_package(PHP4 5.3 REQUIRED)
+endif (NOT PHP4_INCLUDE_PATH OR NOT PHP4_EXECUTABLE)
 
-if (PHP4_FOUND)
+if (PHP4_FOUND OR (PHP4_INCLUDE_PATH AND PHP4_EXECUTABLE))
     include_directories(${PHP4_INCLUDE_PATH})
+
+    # In an additional twist on Debian (Wheezy) - the PHP headers are fubar. php.h is in main/,
+    # TSRM/TSRM.h includes <tsrm_config.h> instead of "tsrm_config.h", and we require
+    # Zend/zend.h (included, of course, as "zend.h" without -I/usr/include/php5/Zend)
+    include_directories("${PHP4_INCLUDE_PATH}/Zend" "${PHP4_INCLUDE_PATH}/TSRM" "${PHP4_INCLUDE_PATH}/main")
     add_library(phpbindings SHARED ${KOLAB_SWIG_PHP_SOURCE_FILE})
-    target_link_libraries(phpbindings kolabxml ${PHP_LIBRARIES})
+    target_link_libraries(phpbindings kolabxml)
     SET_TARGET_PROPERTIES(phpbindings PROPERTIES OUTPUT_NAME "kolabformat")
     SET_TARGET_PROPERTIES(phpbindings PROPERTIES PREFIX "")
 
@@ -39,6 +48,6 @@
             ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.php
             DESTINATION ${PHP_INSTALL_DIR}
         )
-else(PHP4_FOUND)
+else(PHP4_FOUND OR (PHP4_INCLUDE_PATH AND PHP4_EXECUTABLE))
     message(WARNING "not building php bindings because php was not found")
-endif (PHP4_FOUND)
+endif (PHP4_FOUND OR (PHP4_INCLUDE_PATH AND PHP4_EXECUTABLE))

=== src/python/CMakeLists.txt ===
# Generate Python wrapper
include_directories(../)

# Compile Python Bindings

find_package(PythonLibs REQUIRED)

if (NOT PYTHONLIBS_FOUND)
    message("python libs not found, not building python bindings")
    return()
endif()
message("found python include dirs: ${PYTHON_INCLUDE_DIRS} ${PYTHON_INCLUDE_PATH}")

set(KOLAB_SWIG_PYTHON_SOURCE_FILE ${CMAKE_CURRENT_BINARY_DIR}/python_kolabformat_wrapper.cpp)
set(KOLAB_SWIG_PYTHON_HEADER_FILE ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.py)

add_custom_command(OUTPUT ${KOLAB_SWIG_PYTHON_SOURCE_FILE} ${KOLAB_SWIG_PYTHON_HEADER_FILE}
    COMMAND ${SWIG} -v -c++ -python -o ${KOLAB_SWIG_PYTHON_SOURCE_FILE} ../kolabformat.i
    COMMENT "Generating python bindings"
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ../kolabformat.i kolabxml
    VERBATIM
    )

SET_SOURCE_FILES_PROPERTIES(${KOLAB_SWIG_PYTHON_SOURCE_FILE} PROPERTIES GENERATED 1)

#${PYTHON_INCLUDE_PATH} is for backwards compatibility (el6)
include_directories(${PYTHON_INCLUDE_DIRS} ${PYTHON_INCLUDE_PATH})

set(PYTHON_MODULE_PREFIX "_")
python_add_module(kolabformat ${KOLAB_SWIG_PYTHON_SOURCE_FILE})

#cmake 2.6.4 fails to respect the module prefix
SET_TARGET_PROPERTIES(kolabformat PROPERTIES PREFIX "${PYTHON_MODULE_PREFIX}")

target_link_libraries(kolabformat kolabxml ${PYTHON_LIBRARIES})
configure_file(test.py ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)

set(PYTHON_INSTALL_DIR "${CMAKE_CURRENT_BINARY_DIR}/pythonbindings" CACHE STRING "Install directory for python bindings.")

install(TARGETS kolabformat LIBRARY DESTINATION ${PYTHON_INSTALL_DIR})

install( FILES
        ${KOLAB_SWIG_PYTHON_HEADER_FILE}
        DESTINATION ${PYTHON_INSTALL_DIR}
    )

=== debian/changelog ===
libkolabxml (0.8.2-0ubuntu3) raring; urgency=low

  * Don't depend on libcurl4-gnutls-dev after all, as it causes conflicts with
    the openssl variant of curl

 -- Philip Muškovac <yofel@kubuntu.org>  Thu, 31 Jan 2013 16:47:54 +0100

libkolabxml (0.8.2-0ubuntu2) raring; urgency=low

  * Make libkolabxml-dev depend on libboost-system1.49-dev,
    libboost-thread1.49-dev, libcurl4-gnutls-dev and libxerces-c-dev
    which are required by the cmake configuration for anything that
    uses libkolabxml.
  * Build-depend on the 1.49 boost package instead of the unversioned ones

 -- Philip Muškovac <yofel@kubuntu.org>  Thu, 31 Jan 2013 15:12:05 +0100

libkolabxml (0.8.2-0ubuntu1) raring; urgency=low

  [ Prasad Murthy ]
  * New upstream release
    - Removed kubuntu_fix_curl_constness.patch, applied upstream
    - Add libboost-system-dev to Build-depends
    
  [ Philip Muškovac ]
  * Build-depend on swig instead of swig2.0 as 2.0 isn't used 
  * Build-depend on libqt4-dev so the tests are built

 -- Prasad Murthy <phoenix_firebrd@yahoo.com>  Thu, 24 Jan 2013 06:15:45 +0530

=== debian/control ===
--- 
+++ 
@@ -8,10 +8,12 @@
                libxerces-c-dev,
                xsdcxx,
                uuid-dev,
-               libboost-dev,
-               libboost-thread-dev,
-               swig2.0,
+               libboost1.49-dev,
+               libboost-thread1.49-dev,
+               swig,
                libcurl4-gnutls-dev,
+               libboost-system1.49-dev,
+               libqt4-dev
 Standards-Version: 3.9.3
 Homepage: http://git.kolab.org/libkolabxml
 
@@ -26,7 +28,10 @@
 Section: libdevel
 Architecture: any
 Depends: libkolabxml0 (= ${binary:Version}),
-         ${misc:Depends}
+         ${misc:Depends},
+         libboost-system1.49-dev,
+         libboost-thread1.49-dev,
+         libxerces-c-dev
 Description: Kolab Format 3.0 serialization, read and write library
  libkolabxml is a slim, lightweight Kolab Format 3.0 serialization,
  read and write library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

#override_dh_auto_configure:
#	dh_auto_configure -- -DINCLUDE_INSTALL_DIR=include/kolab

## libkolabxml 0.8.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,7 @@
 cmake_minimum_required(VERSION 2.6)
 
 option( BUILD_TESTS "Build the tests" TRUE )
+option( BUILD_UTILS "Build optional utils" FALSE )
 option( DIST_ONLY "Build dist targets only (does not require a compiler)" FALSE )
 option( PYTHON_BINDINGS "Build bindings for python" FALSE )
 option( PHP_BINDINGS "Build bindings for php" FALSE )
@@ -42,7 +43,7 @@
 set (Libkolabxml_VERSION_MAJOR 0)
 set (Libkolabxml_VERSION_MINOR 8)
 # Enable the full x.y.z version only for release versions
-set (Libkolabxml_VERSION_PATCH 2)
+set (Libkolabxml_VERSION_PATCH 4)
 set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}.${Libkolabxml_VERSION_PATCH}" )
 # set (Libkolabxml_VERSION "${Libkolabxml_VERSION_MAJOR}.${Libkolabxml_VERSION_MINOR}" )
 
@@ -135,7 +136,7 @@
 # --generate-inline --extern-xml-schema xml-schema.xsd
 # --cxx-suffix .cpp --hxx-suffix .h   
 add_custom_command(OUTPUT ${SCHEMA_SOURCEFILES}
-    COMMAND ${XSDCXX} cxx-tree --generate-polymorphic --generate-serialization  --namespace-map http://kolab.org=KolabXSD --root-element icalendar --root-element vcards --root-element note --root-element configuration --output-dir ${CMAKE_BINARY_DIR}/bindings ${SCHEMAS}
+    COMMAND ${XSDCXX} cxx-tree --generate-polymorphic --generate-serialization  --namespace-map http://kolab.org=KolabXSD --root-element icalendar --root-element vcards --root-element note --root-element configuration --root-element file --output-dir ${CMAKE_BINARY_DIR}/bindings ${SCHEMAS}
     COMMENT "Generating XSD bindings"
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
     DEPENDS ${SCHEMAS}
@@ -179,6 +180,10 @@
 
 add_subdirectory(src)
 
+if (BUILD_UTILS)
+    add_subdirectory(utils)
+endif()
+
 if (BUILD_TESTS)
     enable_testing()
     add_subdirectory(tests)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
     containers/kolabcontact.cpp
     containers/kolabconfiguration.cpp
     containers/kolabfreebusy.cpp
+    containers/kolabfile.cpp
     utils.cpp base64.cpp uriencode.cpp
     ../compiled/XMLParserWrapper.cpp
     ../compiled/grammar-input-stream.cxx
@@ -54,6 +55,7 @@
     containers/kolabcontainers.h
     containers/kolabconfiguration.h
     containers/kolabfreebusy.h
+    containers/kolabfile.h
     global_definitions.h
     DESTINATION ${INCLUDE_INSTALL_DIR})

=== src/csharp/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,7 @@
         ${CMAKE_CURRENT_BINARY_DIR}/Duration.cs
         ${CMAKE_CURRENT_BINARY_DIR}/ErrorSeverity.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Event.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/File.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Geo.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Journal.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Key.cs
@@ -44,6 +45,7 @@
         ${CMAKE_CURRENT_BINARY_DIR}/Role.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Status.cs
         ${CMAKE_CURRENT_BINARY_DIR}/SWIGTYPE_p_Kolab__Freebusy.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/SWIGTYPE_p_std__vectorT_Kolab__Todo_t.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Telephone.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Todo.cs
         ${CMAKE_CURRENT_BINARY_DIR}/Url.cs
@@ -57,6 +59,7 @@
         ${CMAKE_CURRENT_BINARY_DIR}/vectorcs.cs
         ${CMAKE_CURRENT_BINARY_DIR}/vectordatetime.cs
         ${CMAKE_CURRENT_BINARY_DIR}/vectordaypos.cs
+        ${CMAKE_CURRENT_BINARY_DIR}/vectorevent.cs
         ${CMAKE_CURRENT_BINARY_DIR}/vectorgeo.cs
         ${CMAKE_CURRENT_BINARY_DIR}/vectori.cs
         ${CMAKE_CURRENT_BINARY_DIR}/vectorkey.cs

=== src/php/CMakeLists.txt ===
#Generate PHP wrapper
include_directories(../)

set(KOLAB_SWIG_PHP_SOURCE_FILE php_kolabformat_wrapper.cpp)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${KOLAB_SWIG_PHP_SOURCE_FILE} ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.php
        COMMAND ${SWIG} -v -c++ -php -o ${CMAKE_CURRENT_BINARY_DIR}/${KOLAB_SWIG_PHP_SOURCE_FILE}  ../kolabformat.i
        COMMENT "Generating php bindings"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS ../kolabformat.i kolabxml
        VERBATIM
    )

set_source_files_properties(${KOLAB_SWIG_PHP_SOURCE_FILE} PROPERTIES GENERATED 1)
add_custom_target(generate_php_bindings ALL DEPENDS ${KOLAB_SWIG_PHP_SOURCE_FILE})


#Compile PHP Bindings
# Since there is no php library we can't compile with -Wl,--no-undefined
if (APPLE)
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flat_namespace -undefined suppress" )
endif()

# Try to find PHP5
find_path(PHP_INCLUDE_DIR NAMES main/php.h PATH_SUFFIXES php php5)
find_program(PHP_EXECUTABLE NAMES php)

# Libkolabxml needs PHP >= 5.3
set(PHP_MIN_VERSION 50300)

# Find where to install the extension files if it's not defined
if(NOT DEFINED PHP_INSTALL_DIR)
  find_program(PHP_CONFIG_EXECUTABLE NAMES php-config)
  if(PHP_CONFIG_EXECUTABLE)
    execute_process(COMMAND ${PHP_CONFIG_EXECUTABLE} --extension-dir
                    OUTPUT_VARIABLE _php_extensions_dir
    )
    string(REGEX REPLACE "\n" "" _php_extensions_dir "${_php_extensions_dir}")
    set(PHP_INSTALL_DIR ${_php_extensions_dir} CACHE STRING "Install directory for PHP bindings.")
  else()
    set(PHP_INSTALL_DIR ${LIB_INSTALL_DIR}/extensions)
  endif()
endif()

if(PHP_INCLUDE_DIR AND PHP_EXECUTABLE)
  file(READ ${PHP_INCLUDE_DIR}/main/php_version.h PHP_VERSION_CONTENT)
  string(REGEX MATCH "#define PHP_VERSION_ID[ ]*[0-9]*\n" _PHP_VERSION_ID_MATCH ${PHP_VERSION_CONTENT})
  if(_PHP_VERSION_ID_MATCH)
    string(REGEX REPLACE "#define PHP_VERSION_ID[ ]*([0-9]*)\n" "\\1" PHP_VERSION_ID ${_PHP_VERSION_ID_MATCH})
  endif()

  # Include the needed PHP5 subdirs
  set(PHP_INCLUDE_DIRS ${PHP_INCLUDE_DIR} ${PHP_INCLUDE_DIR}/main ${PHP_INCLUDE_DIR}/TSRM ${PHP_INCLUDE_DIR}/Zend )
endif()

if(NOT PHP_VERSION_ID VERSION_LESS ${PHP_MIN_VERSION})
  include_directories(${PHP_INCLUDE_DIRS})
  add_library(phpbindings SHARED ${KOLAB_SWIG_PHP_SOURCE_FILE})
  target_link_libraries(phpbindings kolabxml)
  set_target_properties(phpbindings PROPERTIES OUTPUT_NAME "kolabformat")
  set_target_properties(phpbindings PROPERTIES PREFIX "")

  configure_file(test.php ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)

  install(TARGETS phpbindings LIBRARY DESTINATION ${PHP_INSTALL_DIR})

  install( FILES
          ${CMAKE_CURRENT_BINARY_DIR}/kolabformat.php
          DESTINATION ${PHP_INSTALL_DIR}
      )

else()
  message(WARNING "not building php bindings because php was not found")
endif()

=== debian/changelog ===
libkolabxml (0.8.4-5) unstable; urgency=low

  * Fix parallel build issue
  * Remove unused override
  * Upgrade to standards version 3.9.4
  * Fix dependency issues on libkolabxml-dev (Closes: #714102)
    - Disable transitive linking
    - Depend libkolabxml-dev on libboost-dev
  * Close race condition bug, see previous entry (Closes: #710568)
  * Fix changelog syntax re. closing bugs
  * Disable verbosity

 -- Paul Klos <kolab@klos2day.nl>  Thu, 11 Jul 2013 20:55:47 +0200

libkolabxml (0.8.4-4) unstable; urgency=low

  * Fix race condition
    php_kolabformat.h was accessed before generation was complete
  * Update changelog

 -- Paul Klos <kolab@klos2day.nl>  Sat, 15 Jun 2013 14:10:23 +0200

libkolabxml (0.8.4-3) unstable; urgency=low

  * Upload to Debian
  * Fix file not found error during dh_install

 -- Paul Klos <kolab@klos2day.nl>  Fri, 17 May 2013 23:03:10 +0200

libkolabxml (0.8.4-2) unstable; urgency=low

  * Update changelog
  * Make all descriptions end with a period.
  * Updated copyright
    Added FLOSS exception from http://www.codesynthesis.com/projects/xsd/FLOSSE
  * Use dh_makeshlibs override instead of shlibs file
  * Add GPL-3 paragraph
  * Fix shlibs
  * Move kolabformat.ini into debian/

 -- Paul Klos <kolab@klos2day.nl>  Mon, 13 May 2013 22:25:37 +0200

libkolabxml (0.8.4-1) unstable; urgency=low

  * Remove empty line
  * Imported Upstream version 0.8.4
  * Update changelog
  * Correct search for PHP version and include dirs
  * Remove unused cmake arguments
  * Remove unused verbosity
  * Add bug to patch description

 -- Paul Klos <kolab@klos2day.nl>  Sat, 13 Apr 2013 22:10:16 +0200

libkolabxml (0.8.3-2) unstable; urgency=low

  * Prepare for transition into Debian proper

 -- Paul Klos <kolab@klos2day.nl>  Sat, 13 Apr 2013 00:19:04 +0200

libkolabxml (0.8.3-1) unstable; urgency=low

  * Imported upstream version 0.8.3

 -- Paul Klos <kolab@klos2day.nl>  Fri, 01 Mar 2013 11:12:38 +0100

libkolabxml (0.8.1-5) unstable; urgency=low

  [ Paul Klos ]
  * Install kolabformat.ini to usr/share/php5/kolab
  * Have maintainer scripts manage kolabformat.ini

  [ Jeroen van Meeuwen ]
  * Rebuild

 -- Paul Klos <kolab@klos2day.nl>  Fri, 19 Oct 2012 20:02:17 +0200

libkolabxml (0.8.1-3.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fixing lintian errors

 -- Paul Klos <kolab@klos2day.nl>  Sat, 13 Oct 2012 14:00:00 +0200

libkolabxml (0.8.1-3.1) UNRELEASED; urgency=low

  [ Jeroen van Meeuwen (Kolab Systems) ]
  * Resolve hardcoded libc dependency
  * Correct identity for maintainer
  * Fix typo

  [ Michael Kiefer <Michael-Kiefer@web.de> ]
  * Changed dependency for phpapi to allow phpapi-20100525+lfs 

 -- Michael Kiefer <Michael-Kiefer@web.de>  Sat, 29 Sep 2012 21:36:35 +0200

libkolabxml (0.8.1-2) unstable; urgency=low

  [ Jeroen van Meeuwen (Kolab Systems) ]
  * Make the variables used be explicitly executed in shell
  * Attempt to include shlibs with libkolabxml0

  [ Kolab Systems User ]

 -- Jeroen van Meeuwen (Kolab Systems) <vanmeeuwen@kolabsys.com>  Sat, 08 Sep 2012 19:25:44 +0200

libkolabxml (0.8.1-1) unstable; urgency=low

  * Build for Debian Wheezy

 -- Jeroen van Meeuwen <vanmeeuwen@kolabsys.com>  Fri,  7 Sep 2012 14:07:50 +0100

=== debian/control ===
Source: libkolabxml
Section: libs
Priority: optional
Maintainer: Debian Kolab Maintainers <pkg-kolab-devel@lists.alioth.debian.org>
Uploaders: Jeroen van Meeuwen (Kolab Systems) <vanmeeuwen@kolabsys.com>, Paul Klos <kolab@klos2day.nl>
Build-Depends: cmake,
               debhelper (>= 9),
               libxerces-c-dev,
               xsdcxx,
               uuid-dev,
               libboost-dev,
               libboost-system-dev,
               libboost-thread-dev,
               swig,
               libcurl4-gnutls-dev,
               php5-dev,
               python-dev (>= 2.7),
X-Python-Version: >= 2.7
Standards-Version: 3.9.4
Homepage: http://git.kolab.org/libkolabxml

Package: libkolabxml0
Architecture: any
Depends: ${misc:Depends},
	${shlibs:Depends}
Description: Kolab XML format (shared library)
 Libkolabxml is the reference implementation of the Kolab XML format.
 .
 The Kolab 3.0 XML format is defined in
 <http://wiki.kolab.org/User:Mollekopf/Drafts/KEP:17>.
 .
 This package provides serialization/deserialization from/to  in-memory
 representations for all Kolab Objects, including input validation.

Package: php-kolabformat
Architecture: any
Depends: libkolabxml0 (= ${binary:Version}),
	${misc:Depends},
	${shlibs:Depends},
	${php:Depends},
    ucf
Description: PHP bindings for Kolab Format 3.0 XML parsing
 Libkolabxml is the reference implementation of the Kolab XML format
 For more information see the libkolabxml package.
 .
 This package provides PHP bindings for libkolabxml.

Package: python-kolabformat
Architecture: any
Section: python
Depends: libkolabxml0 (= ${binary:Version}),
	python,
	${misc:Depends},
	${shlibs:Depends}
Description: Python bindings for Kolab Format 3.0 XML parsing
 Libkolabxml is the reference implementation of the Kolab XML format.
 For more information see the libkolabxml package.
 .
 This package provides Python bindings for libkolabxml.

Package: libkolabxml-dev
Section: libdevel
Architecture: any
Depends: libkolabxml0 (= ${binary:Version}),
         ${misc:Depends}, libboost-dev
Description: Development files for libkolabxml
 Libkolabxml is the reference implementation of the Kolab XML format.
 For more information see the libkolabxml package.
 .
 This package provides development files libkolabxml.

=== debian/rules ===
#!/usr/bin/make -f

PHPAPI := $(shell php-config --phpapi)
PYTHON_SITEARCH := $(shell python -c 'from distutils.sysconfig import get_python_lib; print get_python_lib(1)')

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND="-Wl,--as-needed"

%:
	dh $@ --parallel --with python2

override_dh_gencontrol:
	echo "php:Depends=phpapi-${PHPAPI}" >> debian/php-kolabformat.substvars
	dh_gencontrol

override_dh_auto_configure:
	dh_auto_configure -- \
		-DPHP_BINDINGS=ON \
		-DPYTHON_BINDINGS=ON \
		-DPYTHON_INSTALL_DIR=$(PYTHON_SITEARCH)

override_dh_install:
	mkdir -p debian/tmp/usr/share/php
	mv debian/tmp/usr/lib/php5/$(PHPAPI)/kolabformat.php debian/tmp/usr/share/php/kolabformat.php
	dh_install --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -V 'libkolabxml0 (>= 0.8.4)'
